<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" 
    href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" 
    integrity="sha384-JcKb8q3iqJ61gNV9KGb8thSsNjpSL0n8PARn9HuZOnIxN0hoP+VmmDGMN5t9UJ0Z" 
    crossorigin="anonymous">

</head>
<body>
    <h2 class="py-3 text-center">
        <span class="mx-3">Elecciones Presidenciales</span>
    </h2>

    <div class="row m-auto px-5">
        <div class="col-12 col-sm-3">
            <form>
                <div class="form-group">
                    <h5>Agregar Candidato</h5>
                    <label>Nombre</label>
                    <input type="text" class="form-control" required />
                </div>
                <div class="form-group">
                    <label>Foto (URL)</label>
                    <input type="text" class="form-control" required />
                </div>
                <div class="form-group">
                    <label>Color Representativo</label>
                    <input type="color" class="form-control" />
                </div>
                <button type="submit" class="btn btn-primary mb-3">Agregar</button>
            </form>
            <br />
            <form>
                <div class="form-group">
                    <h5>Registrar Votos</h5>
                    <label>Region</label>
                    <select class="form-control">
                        <option selectec disable>Seleccione su Region</option>
                        <option value="AI">Aysén del General Carlos Ibáñez del Campo</option>
                        <option value="AN">Antofagasta</option>
                        <option value="AP">Arica y Parinacota</option>
                        <option value="AR">Araucanía</option>
                        <option value="AT">Atacama</option>
                        <option value="BI">Biobío</option>
                        <option value="CO">Coquimbo</option>
                        <option value="OH">Libertador General Bernardo O'Higgins</option>
                        <option value="LL">Los Lagos</option>
                        <option value="LR">Los Ríos</option>
                        <option value="MG">Magallanes y la Antártica Chilena</option>
                        <option value="MA">Maule</option>
                        <option value="NB">Ñuble</option>
                        <option value="RM">Metropolitana de Santiago</option>
                        <option value="TA">Tarapacá</option>
                        <option value="VA">Valparaíso</option>	
                    </select>
                </div>
                <div class="form-group">
                    <label>Votos</label>
                    <input type="number" class="form-control" required />
                </div>
                <div>
                    <label>GANADOR CADEM</label>
                    <select class="form-control" id="ganador"></select>
                </div>
                <button type="submit" class="btn btn-success mb-3">Registrar</button>
                <p id="creado" class="text-whitem p-3 d-none"></p>
            </form>
        </div>
        <div class="col-12 col-sm-6 px-5 row candidatos align-items-start"></div>
        <div class="col-12 col-sm-3 px-5">
            <h5>Resultado de las Votaciones</h5>
            <table class="table bg-light">
                <thead>
                    <th>Region</th>
                    <th>Votos</th>
                    <th>Ganador</th>
                </thead>
                <tbody></tbody>
            </table>
        </div>
    </div>

    <!--JQUERY-->
    <script
        src="https://code.jquery.com/jquery-3.5.1.slim.js"
        integrity="sha256-DrT5NfxfbHvMHux31Lkhxg42LY6of8TaYyK50jnxRnM="
        crossorigin="anonymous">
    </script>
    <!--JSDelivr-->
    <script
        src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"
        integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN"
        crossorigin="anonymous"
    ></script>
    <script
        src="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/js/bootstrap.min.js"
        integrity="sha384-w1Q4orYjBQndcko6MimVbzY0tgp4pWB4lZ7lr30WKz0vr/aWKhXdBNmNb5D92v7s"
        crossorigin="anonymous"
    ></script>
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>

    <div class="modal fade" id="modal" tabindex="-1" role="dialog" 
    aria-labelledby="Modal" aria-hidden="true">
        <div class="modal-dialog text-dark" role="document">
            <div class="modal-content">
                <div class="modal-body">
                    <div class="row">
                        <div class="col-2">Nombre</div>
                        <div class="col-10">
                            <input id="nombreEdit" type="text" class="form-control" />
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-2">Foto</div>
                        <div class="col-10">
                            <input id="fotoEdit" type="text" class="form-control" />
                        </div>
                    </div>
                    <button class="btn btn-warning" id="editButton">Editar</button>
                </div>
            </div>
        </div>
    </div>
</body>
</html>

<style>
    body {
      background: #1c3174;
      color: white;
    }
    form {
      padding: 15px;
      background: #0d47a1;
      color: white;
    }
  
    .card-body {
      background: #e1e2e1;
    }
  
    .card-body div span {
      cursor: pointer;
    }
  
    #creado {
      background: #002b55;
    }
  
    .card {
      background: transparent !important;
      border: none !important;
    }
  </style>
    <script>
        function setInfoModal(nombre, foto, id){
            $("#nombreEdit").val(nombre);
            $("#fotoEdit").val(foto);

            $("#editButton").attr("onclick",`editCandidato${id}`)
        }

        async function editCandidato(id){
            const nombre = $("nombreEdit").val();
            const foto = $("fotoEdit").val();

            const { data } = await axios.put("http://localhost:3000/candidato", {
                nombre,
                foto,
                id,
            });
            $("#modal").modal('hide');
            location.reload();
        }

        $("form:first").submit(async (e) => {
            e.preventDefault();
            let nombre = $("form:first input:first").val();
            let foto = $("form:first input:nth-child(2)").val();
            let color = $("form:first input:last").val();
            
            const response = await fetch("http://localhost:3000/candidato",{
                method: "post",
                body: JSON.stringify({
                    nombre,
                    foto,
                    color,
                }),
            });
            $("form:first input:first").val("");
            $("form:first input:nth-child(2)").val("");
            $("form:first input:last").val("");
            location.reload();
        });

        $("form:last").submit(async (e) =>{
            e.preventDefault();
            let region = $("form:last select:first").val();
            let votos = $("form:last input").val();
            let ganador = $("#ganador").val();

            if(!ganador || !region){
                alert("Selecciona la Region y el Ganador");
                return false;
            }

            try{
                const response = await fetch("http://localhost:3000/votos",{
                    method: "post",
                    body: JSON.stringify({
                        region,
                        votos,
                        ganador,
                    }),
                });
                const data = await response.json();
                location.reload();
            }catch(e){
                alert("Fraude!!!... ya existe un registro para la region!");
            }
        });

        async function getCandidatos(){
            const response = await fetch("http://localhost:3000/candidatos");
            let data = await response.json();
            $(".candidatos").html("");
            $("#ganador").html(
                "<option disable selected>Seleccione Ganador</option>"
            );
            data = data.sort(function(a,b){
                if(a.votos < b.votos) {
                    return 1;
                }
                if(a.votos > b.votos) {
                    return -1;
                }
                return 0;
            });
            $.each(data, (i, c) => {
      $(".candidatos").append(`
      <div class="pb-4 px-4 pt-0 col-6"  >
          <div class="card w-100 " style="background: ${c.color}
          ; border: solid 2px ${c.color} !important; 
          ${c.votos == Math.max(...data.map((c) => c.votos))
          ? "box-shadow: 1px 1px 15px 1px yellow"
          : ""}" >
            <img
              class="card-img-top"
              src="${c.foto}"
              alt="Card image cap"
            />
            <div class="card-body d-flex justify-content-between" style="background: ${
              c.color} !important">
              <h5 class="card-title mb-0">${c.nombre}</h5>
              <div>
                <span data-toggle="modal" data-target="#modal" onclick="setInfoModal('${
                  c.nombre}','${c.foto}', '${c.id}' )"
                  >&#9998;</span>
                <span onclick="eliminarCandidato(${c.id})">&#10060;</span>
              </div>

              </div>
              <h5 class="text-center py-2">Votos: ${c.votos}</h5>
          </div>
        </div>
        `);
                $("#ganador").append(
                    `<option value="${c.nombre}">${c.nombre}</option>`
                );
            });
        };

        async function deleteCandidato(id){
            const response = await fetch(`http://localhost:3000/candidato?id=${id}`,{
                method: "DELETE",
            })
            getCandidatos(); 
        }

        async function getHistorial() {
            const { data } = await axios.get("http://localhost:3000/historial");
            $("tbody").html(``);

            data.forEach((v) =>{
                $("tbody").append(
                    `
                    <tr>
                        <td>${v[0]}</td>
                        <td>${v[1]}</td>
                        <td>${v[2]}</td>
                    </tr>
                    `
                )
            })
        }

        getCandidatos();
        getHistorial();

    </script>
